codeforces_731C_[dfs][并查集]

C. Socks
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Arseniy is already grown-up and independent. His mother decided to leave him alone for m days and left on a vacation. She have prepared a lot of food, left some money and washed all Arseniy's clothes.

Ten minutes before her leave she realized that it would be also useful to prepare instruction of which particular clothes to wear on each of the days she will be absent. Arseniy's family is a bit weird so all the clothes is enumerated. For example, each of Arseniy's n socks is assigned a unique integer from 1 to n. Thus, the only thing his mother had to do was to write down two integers li and ri for each of the days — the indices of socks to wear on the day i(obviously, li stands for the left foot and ri for the right). Each sock is painted in one of k colors.

When mother already left Arseniy noticed that according to instruction he would wear the socks of different colors on some days. Of course, that is a terrible mistake cause by a rush. Arseniy is a smart boy, and, by some magical coincidence, he posses k jars with the paint — one for each of k colors.

Arseniy wants to repaint some of the socks in such a way, that for each of m days he can follow the mother's instructions and wear the socks of the same color. As he is going to be very busy these days he will have no time to change the colors of any socks so he has to finalize the colors now.

The new computer game Bota-3 was just realised and Arseniy can't wait to play it. What is the minimum number of socks that need their color to be changed in order to make it possible to follow mother's instructions and wear the socks of the same color during each of m days.

Input

The first line of input contains three integers nm and k (2 ≤ n ≤ 200 000, 0 ≤ m ≤ 200 000, 1 ≤ k ≤ 200 000) — the number of socks, the number of days and the number of available colors respectively.

The second line contain n integers c1, c2, ..., cn (1 ≤ ci ≤ k) — current colors of Arseniy's socks.

Each of the following m lines contains two integers li and ri (1 ≤ li, ri ≤ nli ≠ ri) — indices of socks which Arseniy should wear during the i-th day.

Output

Print one integer — the minimum number of socks that should have their colors changed in order to be able to obey the instructions and not make people laugh from watching the socks of different colors.

Examples
input
3 2 3
1 2 3
1 2
2 3
output
2
input
3 2 2
1 1 2
1 2
2 1
output
0
Note

In the first sample, Arseniy can repaint the first and the third socks to the second color.

In the second sample, there is no need to change any colors.

这道题比赛的时候理解错了。。。

题意:n双袜子,m天,每天穿一双袜子,在已知这m天每天穿的袜子的条件下,问至少改变多少次袜子的颜色,在改过颜色后,每天穿的两只袜子是同种颜色。。

思路:将可能在同一天穿的两只袜子放入一个集合,可以发现改变颜色后最终这个集合中的袜子的颜色是一样的(传递的关系)。所以,在每个集合中将袜子的颜色改为集合中最多的颜色即可。

dfs搜索,搜连通分支中最多的颜色:

#include<cstdio>
#include<set>
#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
using namespace std;
#define N 200005

int sock[N];
int father[N];
int vis[N];
vector<int> v[N];
map<int ,int>mm;
int cnt=0;

void dfs(int x)
{
    if(vis[x]==1)
        return;
    vis[x]=1;
    mm[sock[x]]++;
    cnt=max(cnt,mm[sock[x]]);
    for(int i=0;i<v[x].size();i++)
        dfs(v[x][i]);
}

int main()
{
    int n,m,k;
    scanf("%d%d%d",&n,&m,&k);
    for(int i=1; i<=n; i++)
        scanf("%d",&sock[i]);
    for(int i=0; i<m; i++)
    {
        int l,r;
        scanf("%d%d",&l,&r);
        v[l].push_back(r);
        v[r].push_back(l);
    }
    int tmp=0;
    for(int i=1; i<=n; i++)
    {
        if(vis[i]==0)
        {
            cnt=0;
            mm.clear();
            dfs(i);
            tmp+=cnt;
        }
    }
    printf("%d
",n-tmp);
    return 0;
}


并查集:

#include<cstdio>
#include<set>
#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
using namespace std;
#define N 200005

int sock[N];
int father[N];
int vis[N];
vector<int> v[N];


int Find(int x)
{
    if(father[x]!=x)
        father[x]=Find(father[x]);
    return father[x];
}

void Merge(int x,int y)
{
    int fx=Find(x);
    int fy=Find(y);
    if(fx!=fy)
        father[fx]=fy;
}

int main()
{
    int n,m,k;
    scanf("%d%d%d",&n,&m,&k);
    for(int i=1; i<=n; i++)
    {
        scanf("%d",&sock[i]);
        father[i]=i;
    }
    for(int i=0; i<m; i++)
    {
        int l,r;
        scanf("%d%d",&l,&r);
        if(l!=r)
            Merge(l,r);
    }
    for(int i=1; i<=n; i++)
    {
        int fi=Find(i);
        v[fi].push_back(sock[i]);
    }
    int res=0;
    for(int i=1; i<=n; i++)
    {

        //cout<<mm[1]<<endl;
        if(v[i].size()<=1)
            continue;
        map<int ,int>mm;
        int maxn=0,se=0;
        for(int j=0; j<v[i].size(); j++)
        {
            mm[v[i][j]]++;
            maxn=max(maxn,mm[v[i][j]]);
            se++;
        }
        res+=se-maxn;
    }
    printf("%d
",res);
    return 0;
}
原文地址:https://www.cnblogs.com/jasonlixuetao/p/5971019.html